unit apitestUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, synacode, synautil, httpsend, shellapi,
  OleCtrls, SHDocVw, SHDocVw_EWB, EwbCore, EmbeddedWB, synaoauth, ssl_openssl,
  superobject;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    EmbeddedWB1: TEmbeddedWB;
    AuthorizeButton: TButton;
    GetButton: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure EmbeddedWB1BeforeNavigate2(ASender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure AuthorizeButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GetButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    oauth: tsynaoauth;
    { Public declarations }
    procedure synaoauthcont(value: string);
    function reformatjson(value: string): string;
  end;

var
  Form1: TForm1;

const

  OauthURL = 'http://staging.geocaching.com/OAuth/oauth.ashx';
  oauthmobileurl = 'http://staging.geocaching.com/oauth/mobileoauth.ashx';

  ApiURL = 'https://staging.api.groundspeak.com/Live/V6Beta/Geocaching.svc';

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  if Screen.PixelsPerInch <> PixelsPerInch then
  begin
    ScaleBy(Screen.PixelsPerInch, PixelsPerInch);
  end;
  oauth := tsynaoauth.create;
end;

procedure TForm1.EmbeddedWB1BeforeNavigate2(ASender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var
  oauth_token: string;
  oauth_token_verifier: string;
begin
  memo2.lines.add('bn: ' + url);
  if pos('http://localhost:54386/default.aspx', url)=1 then
  begin
    memo1.lines.Add(url);
    embeddedwb1.Stop;
    synaoauthcont(url);
  end;
end;

procedure TForm1.AuthorizeButtonClick(Sender: TObject);
var
  http: thttpsend;
  s: string;
  response: string;
  url: string;
begin
  http := THttpsend.Create;
  try
    s := oauth.BuildRequest(edit1.text, edit2.text, oauthurl, 'http://localhost:54386/default.aspx');
    memo1.lines.add(s);
    memo1.lines.add(oauth.basestring);

    http.Protocol := '1.1';
    http.UserAgent := 'DotNetOpenAuth/3.4.6.10357';
    http.Document.position := 0;
    writestrtostream(http.Document, s);
    http.Document.position := 0;
    http.MimeType := 'application/x-www-form-urlencoded; charset=utf-8';
    http.HTTPMethod('POST', oAuthURL);
    http.Document.position := 0;
    response := readstrfromstream(http.Document, http.Document.Size);
    memo2.lines.Add(response);

    if not oauth.ParseRequest(response) then
      exit;
    memo2.lines.Add('OK');

//    url := oAuthURL + '?oauth_token='+ encodeurlelement(oauth.request_token)+'&force_login=true';
    url := oauthmobileurl + '?oauth_token='+ encodeurlelement(oauth.request_token)+'&force_login=true';

    embeddedwb1.Navigate(url);

  finally
    http.free;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  oauth.free;
end;

procedure TForm1.synaoauthcont(value: string);
var
  http: thttpsend;
  s: string;
  response: string;
  url: string;
begin
  if not oauth.ParseVerifier(value) then
    exit;
  memo1.lines.Add('verifier OK');

  http := THttpsend.Create;
  try
    s := oauth.BuildAccess(oauthurl);
    memo1.lines.add(s);
    memo1.lines.add(oauth.basestring);

    http.Protocol := '1.1';
    http.UserAgent := 'DotNetOpenAuth/3.4.6.10357';
    http.Document.position := 0;
    writestrtostream(http.Document, s);
    http.Document.position := 0;
    http.MimeType := 'application/x-www-form-urlencoded; charset=utf-8';
    http.HTTPMethod('POST', oAuthURL);
    http.Document.position := 0;
    response := readstrfromstream(http.Document, http.Document.Size);
    memo2.lines.Add(response);
    memo2.lines.Add('AccessToken: ' + oauth.parseAccess(response));
    edit3.Text := oauth.parseAccess(response);
  finally
    http.free;
  end;
end;

procedure TForm1.GetButtonClick(Sender: TObject);
var
  http: thttpsend;
  response: string;
begin
  http := thttpsend.Create;
  try
    http.Protocol := '1.1';
    http.UserAgent := 'Mozilla/5.0 (Windows NT 5.1; rv:5.0) Gecko/20100101';
    http.HTTPMethod('GET', ApiURL + '/' + Combobox1.text + '?AccessToken=' + edit3.Text + '&format=json');
    http.Document.position := 0;
    response := readstrfromstream(http.Document, http.Document.Size);
    memo2.lines.Add(reformatjson(response));
  finally
    http.free;
  end;
end;

function TForm1.reformatjson(value: string): string;
var
  obj: ISuperObject;
begin
  obj := SO(value);
  result := obj.AsJSon(true);
end;

end.
